%global nettle_so_ver 8
%global hogweed_so_ver 6

Summary:        A low-level cryptographic library
Name:           nettle
Version:        3.8.1
Release:        4%{?dist}
License:        LGPLv3+ or GPLv2+
URL:            http://www.lysator.liu.se/~nisse/nettle/
Source0:        http://www.lysator.liu.se/~nisse/archive/%{name}-%{version}.tar.gz
Patch3000:      remove-ecc-testsuite.patch

BuildRequires:  make gcc m4 libtool automake autoconf
BuildRequires:  gmp-devel gettext-devel
BuildRequires:  fipscheck

%description
Nettle is a cryptographic library that is designed to fit easily in more
or less any context: In crypto toolkits for object-oriented languages
(C++, Python, Pike, ...), in applications like LSH or GNUPG, or even in
kernel space.


%package devel
Summary:        Development headers for nettle
Requires:       %{name} = %{version}-%{release}
Requires:       gmp-devel

%description devel
This package contains files needed for developing applications with nettle.


%prep
%autosetup -n %{name}-%{version} -p1

sed s/ggdb3/g/ -i configure
sed 's/ecc-secp192r1.c//g' -i Makefile.in
sed 's/ecc-secp224r1.c//g' -i Makefile.in


%build
autoreconf -ifv
%configure --enable-shared --enable-fat
%make_build


%define fipshmac() \
	fipshmac -d %{buildroot}%{_libdir} %{buildroot}%{_libdir}/%1.* \
	file=`basename %{buildroot}%{_libdir}/%1.*.hmac` && \
	mv %{buildroot}%{_libdir}/$file %{buildroot}%{_libdir}/.$file && \
	ln -s .$file %{buildroot}%{_libdir}/.%1.hmac

%define __spec_install_post \
	%{?__debug_package:%{__debug_install_post}} \
	%{__arch_install_post} \
	%{__os_install_post} \
	%fipshmac libnettle.so.%{nettle_so_ver} \
	%fipshmac libhogweed.so.%{hogweed_so_ver} \
%{nil}


%install
%make_install
make install-shared
install -D -p -m 644 nettle.info $RPM_BUILD_ROOT%{_infodir}/nettle.info
rm -f %{buildroot}%{_libdir}/*.a

chmod 0755 %{buildroot}%{_libdir}/libnettle.so.%{nettle_so_ver}.*
chmod 0755 %{buildroot}%{_libdir}/libhogweed.so.%{hogweed_so_ver}.*


%check
make check


%files
%license COPYINGv2 COPYING.LESSERv3
%doc AUTHORS NEWS README
%{_libdir}/libnettle.so.%{nettle_so_ver}
%{_libdir}/libnettle.so.%{nettle_so_ver}.*
%{_libdir}/libhogweed.so.%{hogweed_so_ver}
%{_libdir}/libhogweed.so.%{hogweed_so_ver}.*
%{_libdir}/.libhogweed.so.*.hmac
%{_libdir}/.libnettle.so.*.hmac
%{_infodir}/nettle.info.*
%exclude %{_bindir}/*


%files devel
%doc descore.README nettle.html nettle.pdf
%{_libdir}/libnettle.so
%{_libdir}/libhogweed.so
%{_libdir}/pkgconfig/hogweed.pc
%{_libdir}/pkgconfig/nettle.pc
%{_includedir}/nettle


%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.8.1-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.8.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.8.1-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Nov 01 2022 rockerzhu <rockerzhu@tencent.com> - 3.8.1-1
- Initial build
